﻿package app.views
{
	import fl.transitions.easing.*;
	import fl.transitions.Tween;
	import fl.transitions.TweenEvent;
	
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	import app.events.MovilEvent;
	
	public class Movil extends Sprite
	{
		public var tw:Tween;
		private var _jump:Boolean = false;
		
		public function Movil() 
		{
			// Dibujamos un circulo que nos servirá como movil
			var gr:Graphics = this.graphics;
			gr.beginFill(0x009966);
			gr.drawCircle(0, 0, 50);
			gr.endFill();
			gr = null;
		}
		
		// Salta
		public function jump():void 
		{
			//Si ya esta saltando, sale
			if ( _jump ) return;
			_jump = true;
			
			//Hacemos que suba 200 pixeles el movil
			tw = new Tween(this, "y", Strong.easeOut, this.y, this.y - 200, .5, true);
			//al terminar de moverse llamará a la función "fell"
			tw.addEventListener(TweenEvent.MOTION_FINISH, fell);
		}
		
		// Cae
		private function fell(e:TweenEvent):void 
		{
			tw.removeEventListener(TweenEvent.MOTION_FINISH, fell);
			
			//Hacemos que baje el movil
			tw = new Tween(this, "y", Regular.easeIn, this.y, this.y + 200, .5, true);
			//al terminar de moverse llamará a la función "fellFinished"
			tw.addEventListener(TweenEvent.MOTION_FINISH, fellFinished);
		}
		
		// Termina de caer
		private function fellFinished(e:TweenEvent):void
		{
			tw.removeEventListener(TweenEvent.MOTION_FINISH, fellFinished);
			
			_jump = false;
			
			//Preparamos el evento a disparar
			var evMovil:MovilEvent = new MovilEvent(MovilEvent.JUMP_FINISHED);
			
			//llevamos alguna variable del Evento con algun dato que queramos
			evMovil.data = "RAW RAW FIGHT DA POWAAA!!!";
			
			//disparamos el evento
			dispatchEvent(evMovil);
		}
		
	}
	
}