﻿package app
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	import app.events.MovilEvent;
	import app.views.Movil;
	
	// Para este ejemplo añadiremos un TextField al escenario y lo llamaremos "txtTrace"
	public class Main extends MovieClip
	{
		private var myMovil:Movil;
		
		public function Main() 
		{
			myMovil = new Movil();
			myMovil.x = 200;
			myMovil.y = 300;
			
			myMovil.addEventListener(MouseEvent.CLICK, movil_onClick);
			myMovil.addEventListener(MovilEvent.JUMP_FINISHED, movil_onJumpFinished);
			
			this.addChild(myMovil);
		}
		
		private function movil_onJumpFinished(e:MovilEvent):void 
		{
			txtTrace.text = "data:" + e.data;
		}
		
		private function movil_onClick(e:MouseEvent):void 
		{
			txtTrace.text = "";
			myMovil.jump();
		}
	}
}